#ifdef INCLUDED_BY_SELF_OPS_C
/* add new statically compiled ops to be instantiated to this list */

OP(clone_stamp);
OP(fetch);
OP(fill_rect);
OP(nop);
OP(over);
OP(png_load);
OP(png_save);
OP(scale);
OP(stamp);
OP(store);
OP(threshold);

#else
#define INCLUDED_BY_SELF_OPS_C

#include <glib.h>
#include "gegl/gegl.h"
#include <stdio.h>

#define OP(name) GType op_##name##_get_type (void);
#include __FILE__
#undef OP

void
ops_init (void)
{
  static gboolean done=FALSE;
  if (done) return;
  done = TRUE;

  fprintf (stderr, "Loading static GeglOps:\n");

  #define OP(name) fprintf (stderr, "\t%s\n", g_type_name(op_##name##_get_type()));
  #include __FILE__
  #undef OP

  fprintf (stderr, "\n");
}

#endif
