#ifndef __OP_COMPOSER_H__
#define __OP_COMPOSER_H__

#include "../gegl/gegl-types.h"
#include "../gegl/gegl-node.h"
#include "../gegl/gegl-operation.h"
#include "canvas/types.h"
//#include "gegl-mock-image.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define TYPE_OP_COMPOSER               (op_composer_get_type ())
#define OP_COMPOSER(obj)               (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_OP_COMPOSER, OpComposer))
#define OP_COMPOSER_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST ((klass),  TYPE_OP_COMPOSER, OpComposerClass))
#define OP_COMPOSER_GET_CLASS(obj)     (G_TYPE_INSTANCE_GET_CLASS ((obj),  TYPE_OP_COMPOSER, OpComposerClass))

typedef struct _OpComposer  OpComposer;
struct _OpComposer
{
    GeglOperation       operation;

    /*< private >*/
    CanvasRect *input;
    CanvasRect *aux;
    CanvasRect *output;

    gboolean    in_place;
};

typedef struct _OpComposerClass OpComposerClass;
struct _OpComposerClass
{
   GeglOperationClass operation_class;
   gboolean (*evaluate) (GeglOperation *self,
                         const gchar   *output_pad);
};

GType             op_composer_get_type                  (void) G_GNUC_CONST;

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
