#ifdef MAGIC_SELF

magic_pointer (canvas)
magic_int     (x,        0,    G_MAXINT,  0)
magic_int     (y,        0,    G_MAXINT,  0)
magic_int     (width,    0,    G_MAXINT,  0)
magic_int     (height,   0,    G_MAXINT,  0)

#else

#define MAGIC_SELF                 "op_store.c"
#define MAGIC_SUPER_CLASS_SINK
#define MAGIC_TypeName             OpStore
#define MAGIC_TypeNameClass        OpStoreClass
#define MAGIC_type_name            op_store
#define MAGIC_type_name_init       op_store_init
#define MAGIC_type_name_class_init op_store_class_init
#include "magic.h"

static gboolean
evaluate (GeglOperation *operation,
          const gchar *output_prop)
{
  OpSink     *op_sink = OP_SINK(operation);
  OpStore    *self    = (OpStore*)(op_sink);
  CanvasRect *input   = op_sink->input;
  CanvasRect *dest_rect;

  if(strcmp("process", output_prop))
    return FALSE;

  g_assert (input);
  g_assert (input->canvas);
  g_assert (self->canvas);

  {
    guchar *buf;
    dest_rect = canvas_rect_new ((Canvas*)self->canvas,
             self->x, self->y,
             input->width, input->height);
    buf = g_malloc (input->width * input->height * 4);
    canvas_rect_export_buf (input, buf);
    canvas_rect_import_buf (dest_rect, buf);
    g_free (buf);
    g_object_unref (dest_rect);
  }

  op_sink->process = TRUE;
  return  TRUE;
}

#endif
